* [PATCH v6 4/5] linux-custom: rewrite to no longer depend on the kernel's builddeb
2019-12-18 19:10 [PATCH v6 0/5] linux-custom recipe rework Jan Kiszka
` (2 preceding siblings ...)
2019-12-18 19:11 ` [PATCH v6 3/5] linux-mainline: update from 4.19.0 to 4.19.88 Jan Kiszka
@ 2019-12-18 19:11 ` Jan Kiszka
2019-12-18 19:11 ` [PATCH v6 5/5] linux-mainline: Test config fragments and LINUX_VERSION_EXTENSION Jan Kiszka
` (2 subsequent siblings)
6 siblings, 0 replies; 9+ messages in thread
From: Jan Kiszka @ 2019-12-18 19:11 UTC (permalink / raw)
To: isar-users
From: Jan Kiszka <jan.kiszka@siemens.com>
Regain control over the packaging of the Linux kernel by providing our
own debian recipes (debian,{control,rules} files and friends) instead
of using the kernel's builddeb script. This will allow generation of
packages for "perf" (not included in this changeset) with per distro
scheme (Debian and Ubuntu have differences) and maintain compatibility
with upstream packages generated from different source packages but
dependent on a certain deployment scheme (e.g. linux-base for Debian).
Based on patch by Cedric Hombourger <Cedric_Hombourger@mentor.com>. This
variant keeps building the kernel-headers package for the host only and
fine-tunes the recipe API.
Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
---
RECIPE-API-CHANGELOG.md | 15 ++
doc/custom_kernel.md | 83 ++++++++
meta/recipes-kernel/linux/files/build-kernel.sh | 125 -------------
meta/recipes-kernel/linux/files/debian/compat | 1 +
.../recipes-kernel/linux/files/debian/control.tmpl | 37 ++++
.../linux/files/debian/isar/build.tmpl | 40 ++++
.../linux/files/debian/isar/clean.tmpl | 21 +++
.../linux/files/debian/isar/common.tmpl | 49 +++++
.../linux/files/debian/isar/install.tmpl | 191 +++++++++++++++++++
.../linux/files/debian/isar/version.cfg.tmpl | 2 +
.../linux/files/debian/linux-image.postinst.tmpl | 30 +++
.../linux/files/debian/linux-image.postrm.tmpl | 36 ++++
.../linux/files/debian/linux-image.preinst.tmpl | 26 +++
.../linux/files/debian/linux-image.prerm.tmpl | 22 +++
meta/recipes-kernel/linux/files/debian/rules.tmpl | 39 ++++
meta/recipes-kernel/linux/linux-custom.inc | 208 +++++++++++++++------
16 files changed, 742 insertions(+), 183 deletions(-)
create mode 100644 doc/custom_kernel.md
delete mode 100644 meta/recipes-kernel/linux/files/build-kernel.sh
create mode 100644 meta/recipes-kernel/linux/files/debian/compat
create mode 100644 meta/recipes-kernel/linux/files/debian/control.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/isar/build.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/isar/clean.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/isar/common.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/isar/install.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/isar/version.cfg.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/linux-image.postinst.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/linux-image.postrm.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/linux-image.preinst.tmpl
create mode 100644 meta/recipes-kernel/linux/files/debian/linux-image.prerm.tmpl
create mode 100755 meta/recipes-kernel/linux/files/debian/rules.tmpl
diff --git a/RECIPE-API-CHANGELOG.md b/RECIPE-API-CHANGELOG.md
index 508e3f55..fb04af99 100644
--- a/RECIPE-API-CHANGELOG.md
+++ b/RECIPE-API-CHANGELOG.md
@@ -193,6 +193,7 @@ files and patches using bbappend a lot easier.
For example:
```
FILESEXTRAPATHS_prepend := "$THISDIR/files:"
+```
### multiconfig build targets were renamed
@@ -209,3 +210,17 @@ The old syntax is no longer supported and will produce an error:
```
bitbake multiconfig:qemuarm-stretch:isar-image-base
```
+
+### Support for kernel config fragments
+
+Kernels built via linux-custom.inc will now get configuration fragments listed
+in SRC_URI automatically applied. Config fragment files need to end on .cfg.
+If such a file should not by applied, append `;apply=no` to the respective
+SRC_URI entry.
+
+### Control over kernel's LOCALVERSION via LINUX_VERSION_EXTENSION
+
+In order to get a LOCALVERSION appendix into both the kernel config and the
+version information of the self-built packages, the LINUX_VERSION_EXTENSION is
+now available. It remains empty by default unless a recipe sets it. The
+appended version usually starts with a "-".
diff --git a/doc/custom_kernel.md b/doc/custom_kernel.md
new file mode 100644
index 00000000..ffeaddc7
--- /dev/null
+++ b/doc/custom_kernel.md
@@ -0,0 +1,83 @@
+# Custom kernel recipe for Isar
+
+## Contents
+
+ - [Summary](#summary)
+ - [Features](#features)
+ - [Future](#future)
+ - [Examples](#examples)
+
+## Summary
+
+Isar provides a recipe to build custom kernels for Debian-based distributions.
+It uses templates to generate the debian meta-data (such as debian/control) and
+Debian's [BuildProfiles](https://wiki.debian.org/BuildProfileSpec) to handle
+some of the distro specific variations. It should be noted that Isar has moved
+away from using the kernel's builddeb script since it would not generate all
+the packages we need (and in particular perf).
+
+## Features
+
+The linux-custom recipe provides support for:
+
+ 1. Sources to the custom Linux kernel may be specified via `SRC_URI`
+
+ 2. Configure the kernel via an in-tree or an external `defconfig` via
+ `KERNEL_DEFCONFIG`
+
+ 3. Integrate kernel configuration tweaks via configuration fragments (`.cfg`
+ files)
+
+ 4. Patches to the linux kernel may be specified via `SRC_URI`
+
+ 5. Ensure that the Isar recipe `PV` matches the kernel release identifier
+ (`KERNEL_RELEASE`)
+
+ 6. Produce a `linux-image` package that ships the kernel image and modules
+
+ 7. Allow the name of the kernel image to be changed via `KERNEL_FILE` (defaults
+ to `vmlinuz`)
+
+ 8. Produce a `linux-headers` package which includes kernel headers and kbuild
+ scripts/tools
+
+ 9. The `linux-headers` package shall support native and cross compiles of
+ out-of-tree kernel modules. However, when built in cross-compilation mode,
+ it cannot be used on the target so far.
+
+ 10. Produce a `linux-libc-dev` package to support user-land builds
+
+ 11. Only build/ship the `linux-libc-dev` package if instructed to
+ (`KERNEL_LIBC_DEV_DEPLOY` equals to `"1"`)
+
+ 12. Support both native and cross compiles (`ISAR_CROSS_COMPILE`)
+
+ 13. Support for the following kernel architectures:
+
+ * arm
+ * arm64
+ * mips
+ * x86
+
+ 14. Support `devshell` (kernel configuration shall be applied)
+
+## Future
+
+In the future, the recipe may be extended to:
+
+ 1. Package perf
+
+ 2. Support inclusion/build of dts files listed in `SRC_URI`
+
+ 3. Be compatible with Ubuntu
+
+ 4. When cross-building, generate kernel-headers for both host and target
+
+## Examples
+
+The linux-custom recipe is currently used by the linux-mainline package and is
+used mainline recipe may be used for some basic testing. This recipe is being
+used by the following machines:
+
+ * de0-nano-soc
+ * qemumipsel
diff --git a/meta/recipes-kernel/linux/files/build-kernel.sh b/meta/recipes-kernel/linux/files/build-kernel.sh
deleted file mode 100644
index 386e58b5..00000000
--- a/meta/recipes-kernel/linux/files/build-kernel.sh
+++ /dev/null
@@ -1,125 +0,0 @@
-#!/bin/bash
-#
-# Custom kernel build
-#
-# This software is a part of ISAR.
-# Copyright (c) Siemens AG, 2018
-#
-# SPDX-License-Identifier: MIT
-
-source /isar/common.sh
-
-host_arch=$(dpkg --print-architecture)
-
-if [ "$host_arch" != "$target_arch" ]; then
- case $target_arch in
- armhf)
- export ARCH=arm
- export CROSS_COMPILE="arm-linux-gnueabihf-"
- ;;
- arm64)
- export ARCH=arm64
- export CROSS_COMPILE="aarch64-linux-gnu-"
- ;;
- mipsel)
- export ARCH=mips
- export CROSS_COMPILE="mipsel-linux-gnu-"
- ;;
- *)
- echo "error: unsupported architecture ($target_arch)"
- exit 1
- ;;
- esac
-fi
-
-REPACK_DIR="$1/../repack"
-REPACK_LINUX_IMAGE_DIR="${REPACK_DIR}/linux-image"
-REPACK_LINUX_HEADERS_DIR="${REPACK_DIR}/linux-headers"
-
-make ${KERNEL_CONFIG_TARGET} || exit ${?}
-
-KV=$( make -s kernelrelease )
-if [ "${KV}" != "${PV}" ]; then
- echo "ERROR: Recipe PV is \"${PV}\" but should be \"${KV}\"" 1>&2
- echo "ERROR: Probably due to CONFIG_LOCALVERSION" 1>&2
- exit 1
-fi
-
-rm -f .version
-KBUILD_DEBARCH=$target_arch make -j $(($(nproc) * 2)) deb-pkg
-
-rm -rf "${REPACK_DIR}"
-mkdir -p "${REPACK_DIR}"
-mkdir -p "${REPACK_LINUX_IMAGE_DIR}"
-mkdir -p "${REPACK_LINUX_HEADERS_DIR}"
-
-cp -a debian "${REPACK_DIR}"
-
-# dpkg-gencontrol performs cross-incompatible checks on the
-# Architecture field; trick it to accept the control file
-sed -i "s/Architecture: .*/Architecture: any/" "${REPACK_DIR}/debian/control"
-
-cd ..
-
-dpkg-deb -R linux-image-${PV}_${PV}-1_*.deb "${REPACK_LINUX_IMAGE_DIR}"
-dpkg-deb -R linux-headers-${PV}_${PV}-1_*.deb "${REPACK_LINUX_HEADERS_DIR}"
-
-dpkg-gencontrol -crepack/debian/control \
- -lrepack/debian/changelog \
- -frepack/debian/files \
- -plinux-image-${PV} \
- -P"${REPACK_LINUX_IMAGE_DIR}" \
- -DPackage="linux-image-${KERNEL_NAME}" \
- -DSection=kernel \
- -DPriority=required \
- -DDepends="${KERNEL_DEBIAN_DEPENDS}" \
- -DArchitecture=$target_arch
-
-# Add Debian-like link installation to postinst
-mkdir -p ${REPACK_LINUX_IMAGE_DIR}/lib/modules/${PV}
-touch "${REPACK_LINUX_IMAGE_DIR}/lib/modules/${PV}/.fresh-install"
-sed -i "${REPACK_LINUX_IMAGE_DIR}/DEBIAN/postinst" \
- -e "/^set -e$/a\\
-\\
-if [ -f /lib/modules/${PV}/.fresh-install ]; then\\
- change=install\\
-else\\
- change=upgrade\\
-fi\\
-linux-update-symlinks \$change ${PV} /boot/${KERNEL_FILE}-${PV}\\
-rm -f /lib/modules/${PV}/.fresh-install"
-
-# Add Debian-like link removal to postrm
-sed -i "${REPACK_LINUX_IMAGE_DIR}/DEBIAN/postrm" \
- -e "/^set -e$/a\\
-\\
-rm -f /lib/modules/${PV}/.fresh-install\\
-\\
-if [ \"\$1\" != upgrade ] && command -v linux-update-symlinks >/dev/null; then\\
- linux-update-symlinks remove ${PV} /boot/${KERNEL_FILE}-${PV}\\
-fi"
-
-# Make sure arm64 kernels are decompressed
-if [ "$target_arch" = "arm64" ]; then
- kernel_file="${REPACK_LINUX_IMAGE_DIR}/boot/${KERNEL_FILE}-${PV}"
- mv "${kernel_file}" "${kernel_file}.gz"
- gunzip "${kernel_file}.gz"
-fi
-
-dpkg-gencontrol -crepack/debian/control \
- -lrepack/debian/changelog \
- -frepack/debian/files \
- -plinux-headers-${PV} \
- -P"${REPACK_LINUX_HEADERS_DIR}" \
- -Vkernel:debarch="${KERNEL_NAME}" \
- -DPackage="linux-headers-${KERNEL_NAME}" \
- -DSection=kernel \
- -DDepends="${KERNEL_HEADERS_DEBIAN_DEPENDS}" \
- -DArchitecture=$target_arch
-
-fakeroot dpkg-deb -b "${REPACK_LINUX_IMAGE_DIR}" \
- linux-image-${KERNEL_NAME}_${PV}-1_${KERNEL_NAME}.deb
-rm -f linux-image-${PV}_${PV}-1_*.deb
-fakeroot dpkg-deb -b "${REPACK_LINUX_HEADERS_DIR}" \
- linux-headers-${KERNEL_NAME}_${PV}-1_${KERNEL_NAME}.deb
-rm -f linux-headers-${PV}_${PV}-1_*.deb
diff --git a/meta/recipes-kernel/linux/files/debian/compat b/meta/recipes-kernel/linux/files/debian/compat
new file mode 100644
index 00000000..ec635144
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/compat
@@ -0,0 +1 @@
+9
diff --git a/meta/recipes-kernel/linux/files/debian/control.tmpl b/meta/recipes-kernel/linux/files/debian/control.tmpl
new file mode 100644
index 00000000..dd0b6245
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/control.tmpl
@@ -0,0 +1,37 @@
+Source: linux-${KERNEL_NAME_PROVIDED}
+Section: kernel
+Priority: optional
+Maintainer: ${MAINTAINER}
+Build-Depends: bc, kmod, cpio, ${KBUILD_DEPENDS}
+Homepage: http://www.kernel.org/
+
+Package: linux-image-${KERNEL_NAME_PROVIDED}
+Architecture: any
+Depends: ${KERNEL_DEBIAN_DEPENDS}
+Description: ${KERNEL_NAME_PROVIDED} Linux kernel, version @KR@
+ This package contains the Linux kernel, modules and corresponding other
+ files, version: @KR@.
+
+Package: linux-headers-${KERNEL_NAME_PROVIDED}
+Architecture: any
+Depends: ${KERNEL_HEADERS_DEBIAN_DEPENDS}, ${perl:Depends}, ${shlib:Depends}
+Description: ${KERNEL_NAME_PROVIDED} Linux kernel headers for @KR@
+ This package provides kernel header files for @KR@ on ${DISTRO_ARCH}
+ .
+ This is useful for people who need to build external modules
+
+Package: linux-libc-dev
+Build-Profiles: <!nolibcdev>
+Section: devel
+Provides: linux-kernel-headers
+Architecture: any
+Description: Linux support headers for userspace development
+ This package provides userspaces headers from the Linux kernel. These headers
+ are used by the installed headers for GNU glibc and other system libraries.
+
+Package: linux-image-${KERNEL_NAME_PROVIDED}-dbg
+Section: debug
+Architecture: any
+Description: Linux kernel debugging symbols for @KR@
+ This package will come in handy if you need to debug the kernel. It provides
+ all the necessary debug symbols for the kernel and its modules.
diff --git a/meta/recipes-kernel/linux/files/debian/isar/build.tmpl b/meta/recipes-kernel/linux/files/debian/isar/build.tmpl
new file mode 100644
index 00000000..17983e4d
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/isar/build.tmpl
@@ -0,0 +1,40 @@
+#!/bin/bash
+# Copyright (c) Mentor Graphics, a Siemens business, 2019
+# SPDX-License-Identifier: MIT
+
+# Load common stuff
+. ${S}/debian/isar/common || exit ${?}
+
+do_build() {
+
+ # Print a few things that are of particular interest
+ print_settings
+
+ # Process existing kernel configuration to make sure it is complete
+ # (use defaults for options that were not specified)
+ ${MAKE} O=${KERNEL_BUILD_DIR} olddefconfig prepare || exit ${?}
+
+ # Transfer effective kernel version into control file and scripts
+ KR=$(${MAKE} O=${KERNEL_BUILD_DIR} -s --no-print-directory kernelrelease)
+ sed -i "s/@KR@/${KR}/g" ${S}/debian/control ${S}/debian/linux-image-${KERNEL_NAME_PROVIDED}.*
+
+ # Trace what we do here
+ set -x
+
+ # Build the Linux kernel
+ ${MAKE} O=${KERNEL_BUILD_DIR} -j $(nproc) || exit ${?}
+
+ # Stop tracing
+ set +x
+}
+
+print_settings() {
+ cat <<EOF
+# Build settings:
+# ---------------
+# ARCH=${ARCH}
+# CROSS_COMPILE=${CROSS_COMPILE}
+EOF
+}
+
+main build ${*}
diff --git a/meta/recipes-kernel/linux/files/debian/isar/clean.tmpl b/meta/recipes-kernel/linux/files/debian/isar/clean.tmpl
new file mode 100644
index 00000000..f9039877
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/isar/clean.tmpl
@@ -0,0 +1,21 @@
+#!/bin/bash
+# Copyright (c) Mentor Graphics, a Siemens business, 2019
+# SPDX-License-Identifier: MIT
+
+# Load common stuff
+. ${S}/debian/isar/common || exit ${?}
+
+do_clean() {
+
+ # Trace what we do here
+ set -x
+
+ rm -rf ${deb_img_dir} ${deb_dbg_dir}
+ rm -rf ${deb_kern_hdrdir}
+ rm -rf ${deb_libc_hdr_dir}
+
+ # Stop tracing
+ set +x
+}
+
+main clean ${*}
diff --git a/meta/recipes-kernel/linux/files/debian/isar/common.tmpl b/meta/recipes-kernel/linux/files/debian/isar/common.tmpl
new file mode 100644
index 00000000..b7752fb6
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/isar/common.tmpl
@@ -0,0 +1,49 @@
+#!/bin/bash
+# Copyright (c) Mentor Graphics, a Siemens business, 2019
+# SPDX-License-Identifier: MIT
+
+# Isar settings
+ARCH=${KERNEL_ARCH}
+KERNEL_PKG_IMAGE=linux-image-${KERNEL_NAME_PROVIDED}
+KERNEL_PKG_KERN_HEADERS=linux-headers-${KERNEL_NAME_PROVIDED}
+KERNEL_PKG_LIBC_HEADERS=linux-libc-dev
+
+# Constants
+KCONF=.config
+
+# Target directories
+deb_top_dir=${S}/debian
+deb_img_dir=${deb_top_dir}/${KERNEL_PKG_IMAGE}
+deb_dbg_dir=${deb_img_dir}-dbg
+deb_kern_hdr_dir=${deb_top_dir}/${KERNEL_PKG_KERN_HEADERS}
+deb_libc_hdr_dir=${deb_top_dir}/${KERNEL_PKG_LIBC_HEADERS}
+
+# Array of packages to be generated
+declare -A kern_pkgs
+
+main() {
+ local target=${1}
+
+ if [ ! -f ${S}/debian/isar/${target} ]; then
+ echo "error: ${target} is not a supported build target!" >&2
+ return 1
+ fi
+
+ # create do_<x> variables for each package to be generated
+ for p in $(unset DEB_HOST_ARCH; dh_listpackages); do
+ kern_pkgs["${p}"]="1"
+ done
+
+ # variables to be exported
+ export ARCH
+
+ # are we cross-compiling?
+ BUILD_ARCH=$(dpkg-architecture -qDEB_BUILD_ARCH)
+ if [ "${BUILD_ARCH}" = "${DISTRO_ARCH}" ]; then
+ # no, make sure CROSS_COMPILE isn't set
+ unset CROSS_COMPILE
+ fi
+
+ # call the actual target script
+ do_${target} || return ${?}
+}
diff --git a/meta/recipes-kernel/linux/files/debian/isar/install.tmpl b/meta/recipes-kernel/linux/files/debian/isar/install.tmpl
new file mode 100644
index 00000000..568fb815
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/isar/install.tmpl
@@ -0,0 +1,191 @@
+#!/bin/bash
+# Copyright (c) Mentor Graphics, a Siemens business, 2019
+# SPDX-License-Identifier: MIT
+
+# Load common stuff
+. ${S}/debian/isar/common || exit ${?}
+
+# Stop on error
+set -e
+
+do_install() {
+
+ # check if our kernel was configured
+ if [ ! -f "${O}/.config" ]; then
+ echo "error: kernel not configured!" >&2
+ return 1
+ fi
+
+ # load its configuration
+ . ${O}/.config
+
+ kimage="$(${MAKE} O=${O} -s --no-print-directory image_name)"
+ krel="$(${MAKE} O=${O} -s --no-print-directory kernelrelease)"
+ case "${ARCH}" in
+ mips|powerpc) kimage_path="boot/vmlinux-${krel}" ;;
+ um) kimage_path="usr/bin/vmlinux-${krel}" ;;
+ *) kimage_path="boot/vmlinuz-${krel}" ;;
+ esac
+
+ print_settings
+
+ # Trace what we do here
+ set -x
+
+ install_image
+ install_hooks
+ install_dtbs
+ install_kmods
+ install_headers
+
+ # Stop tracing
+ set +x
+}
+
+print_settings() {
+ cat <<EOF
+Install settings:
+-----------------
+kimage=${kimage}
+kimage_path=${kimage_path}
+
+EOF
+}
+
+install_image() {
+ install -m 755 -d ${deb_img_dir}/$(dirname ${kimage_path})
+ cp ${O}/${kimage} ${deb_img_dir}/${kimage_path}
+
+ # Make sure arm64 kernels are decompressed
+ if [ "${ARCH}" = "arm64" ]; then
+ mv ${deb_img_dir}/${kimage_path} ${deb_img_dir}/${kimage_path}.gz
+ gunzip -f ${deb_img_dir}/${kimage_path}.gz
+ fi
+
+ install_image_debug
+}
+
+install_image_debug() {
+ # Different tools want the image in different locations
+ # perf
+ mkdir -p ${deb_dbg_dir}/usr/lib/debug/lib/modules/${krel}/
+ cp ${O}/vmlinux ${deb_dbg_dir}/usr/lib/debug/lib/modules/${krel}/
+ # systemtap
+ mkdir -p ${deb_dbg_dir}/usr/lib/debug/boot/
+ ln -s ../lib/modules/$version/vmlinux ${deb_dbg_dir}/usr/lib/debug/boot/vmlinux-${krel}
+ # kdump-tools
+ ln -s lib/modules/${krel}/vmlinux ${deb_dbg_dir}/usr/lib/debug/vmlinux-${krel}
+}
+
+install_hooks() {
+ install -m 755 -d ${deb_img_dir}/etc/kernel/install.d
+ install -m 755 -d ${deb_img_dir}/etc/kernel/postinst.d
+ install -m 755 -d ${deb_img_dir}/etc/kernel/postrm.d
+ install -m 755 -d ${deb_img_dir}/etc/kernel/prerm.d
+
+ initrd="No"
+ [ -z "${CONFIG_BLK_DEV_INITRD}" ] || initrd="Yes"
+
+ for script in postinst postrm preinst prerm; do
+ sed -i -e "s,INITRD=[A-Za-z0-9]*,INITRD=${initrd},g" ${S}/debian/linux-image*.${script}
+ sed -i -e "s,version=.*,version=${krel},g" ${S}/debian/linux-image*.${script}
+ done
+}
+
+install_dtbs() {
+ [ -n "${CONFIG_OF}" ] || return 0
+ ${MAKE} O=${O} INSTALL_DTBS_PATH=${deb_img_dir}/usr/lib/linux-image-${krel} dtbs_install
+}
+
+install_kmods() {
+ [ -n "${CONFIG_MODULES}" ] || return 0
+ ${MAKE} O=${O} INSTALL_MOD_PATH=${deb_img_dir} modules_install
+ touch ${deb_img_dir}/lib/modules/${krel}/.fresh-install
+ rm -fv ${deb_img_dir}/lib/modules/${krel}/build
+ rm -fv ${deb_img_dir}/lib/modules/${krel}/source
+ install_kmods_debug
+}
+
+kmods_sign() {
+ [ -n "${CONFIG_MODULE_SIG_ALL}" ] || return 0
+ ${MAKE} O=${O} INSTALL_MOD_PATH=${deb_img_dir} modules_sign
+}
+
+install_kmods_debug() {
+ [ -n "${CONFIG_DEBUG_INFO}" ] || return 0
+
+ kmod_inst_dir=${deb_img_dir}/lib/modules
+ kmod_debug_dir=${deb_dbg_dir}/usr/lib/debug
+
+ # copy kernels modules to usr/lib/debug
+ mkdir -p ${kmod_debug_dir}
+ tar -C ${kmod_inst_dir}/ -cO --exclude='modules.*' . | tar -C ${kmod_debug_dir}/ -xf -
+ # strip everything but debug sections for modules in usr/lib/debug
+ find ${kmod_debug_dir} -name *.ko -exec ${CROSS_COMPILE}objcopy --only-keep-debug {} \;
+ # and strip debug sections from modules in lib/modules
+ find ${kmod_inst_dir} -name *.ko -exec ${CROSS_COMPILE}objcopy --strip-debug {} \;
+
+ # re-sign stripped kernel modules
+ kmods_sign
+}
+
+headers_check() {
+ ${MAKE} O=${O} headers_check
+}
+
+libc_headers() {
+ mkdir -p ${deb_libc_hdr_dir}
+ ${MAKE} O=${O} headers_install INSTALL_HDR_PATH=${deb_libc_hdr_dir}/usr
+ host_arch=$(dpkg-architecture -a${DISTRO_ARCH} -qDEB_HOST_MULTIARCH)
+ mkdir ${deb_libc_hdr_dir}/usr/include/${host_arch}
+ mv ${deb_libc_hdr_dir}/usr/include/asm ${deb_libc_hdr_dir}/usr/include/${host_arch}/
+}
+
+kernel_tools() {
+ # remove object files
+ find ${destdir}/scripts -type f -name '*.o' |xargs rm -f
+}
+
+kernel_headers() {
+ kernel_headers_dir="usr/src/linux-headers-${krel}"
+ destdir=${deb_kern_hdr_dir}/${kernel_headers_dir}
+ src_hdr_files=$(mktemp)
+ obj_hdr_files=$(mktemp)
+
+ mkdir -p ${destdir}
+ mkdir -p ${deb_kern_hdr_dir}/lib/modules/${krel}
+
+ (cd ${S}; find . -name 'Makefile*' -o -name 'Kconfig*' -o -name '*.pl') >>${src_hdr_files}
+ (cd ${S}; find arch/*/include include scripts -type f -o -type l) >>${src_hdr_files}
+ (cd ${S}; find arch/${ARCH} -name module.lds -o -name Kbuild.platforms -o -name Platform) >>${src_hdr_files}
+ (cd ${S}; find $(find arch/${ARCH} -name include -o -name scripts -type d) -type f) >>${src_hdr_files}
+
+ (cd ${O}; find arch/${ARCH}/include Module.symvers include scripts -type f) >>${obj_hdr_files}
+ if [ -n "${CONFIG_STACK_VALIDATION}" ]; then
+ (cd ${O}; find tools/objtool -type f -executable) >>${obj_hdr_files}
+ fi
+ if [ -n "${CONFIG_GCC_PLUGINS}" ]; then
+ (cd ${O}; find scripts/gcc-plugins -name *.so -o -name gcc-common.h) >>${obj_hdr_files}
+ fi
+
+ # deploy files that were matched above
+ tar -C ${S} -cf - -T - <${src_hdr_files} | tar -C ${destdir} -xf -
+ tar -C ${O} -cf - -T - <${obj_hdr_files} | tar -C ${destdir} -xf -
+
+ # add the kernel config
+ cp ${O}/${KCONF} ${destdir}/.config
+
+ # handle kernel development tools
+ kernel_tools
+
+ # create symlinks
+ ln -sf /${kernel_headers_dir} ${deb_kern_hdr_dir}/lib/modules/${krel}/build
+}
+
+install_headers() {
+ headers_check
+ [ -z ${kern_pkgs["linux-libc-headers"]} ] || libc_headers
+ kernel_headers
+}
+
+main install ${*}
diff --git a/meta/recipes-kernel/linux/files/debian/isar/version.cfg.tmpl b/meta/recipes-kernel/linux/files/debian/isar/version.cfg.tmpl
new file mode 100644
index 00000000..17effe52
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/isar/version.cfg.tmpl
@@ -0,0 +1,2 @@
+CONFIG_LOCALVERSION="${LINUX_VERSION_EXTENSION}"
+# CONFIG_LOCALVERSION_AUTO is not set
diff --git a/meta/recipes-kernel/linux/files/debian/linux-image.postinst.tmpl b/meta/recipes-kernel/linux/files/debian/linux-image.postinst.tmpl
new file mode 100644
index 00000000..3a0d281d
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/linux-image.postinst.tmpl
@@ -0,0 +1,30 @@
+#!/bin/sh
+# based on https://salsa.debian.org/kernel-team/linux/blob/479cb120ecb2b3f2c4d929a7b57860248d6f79bd/debian/templates/image.postinst.in
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Tell initramfs builder whether it's wanted
+export INITRD=Yes
+
+version=@KR@
+image_path=/boot/${KERNEL_FILE}-${version}
+
+if [ "$1" != configure ]; then
+ exit 0
+fi
+
+depmod $version
+
+if [ -f /lib/modules/$version/.fresh-install ]; then
+ change=install
+else
+ change=upgrade
+fi
+linux-update-symlinks $change $version $image_path
+rm -f /lib/modules/$version/.fresh-install
+
+if [ -d /etc/kernel/postinst.d ]; then
+ DEB_MAINT_PARAMS="$*" run-parts --report --exit-on-error --arg=$version \
+ --arg=$image_path /etc/kernel/postinst.d
+fi
+
+exit 0
diff --git a/meta/recipes-kernel/linux/files/debian/linux-image.postrm.tmpl b/meta/recipes-kernel/linux/files/debian/linux-image.postrm.tmpl
new file mode 100644
index 00000000..d3015940
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/linux-image.postrm.tmpl
@@ -0,0 +1,36 @@
+#!/bin/sh -e
+# based on https://salsa.debian.org/kernel-team/linux/blob/479cb120ecb2b3f2c4d929a7b57860248d6f79bd/debian/templates/image.postrm.in
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Tell initramfs builder whether it's wanted
+export INITRD=Yes
+
+version=@KR@
+image_path=/boot/${KERNEL_FILE}-${version}
+
+rm -f /lib/modules/$version/.fresh-install
+
+if [ "$1" != upgrade ] && command -v linux-update-symlinks >/dev/null; then
+ linux-update-symlinks remove $version $image_path
+fi
+
+if [ -d /etc/kernel/postrm.d ]; then
+ DEB_MAINT_PARAMS="$*" run-parts --report --exit-on-error --arg=$version \
+ --arg=$image_path /etc/kernel/postrm.d
+fi
+
+if [ "$1" = purge ]; then
+ for extra_file in modules.dep modules.isapnpmap modules.pcimap \
+ modules.usbmap modules.parportmap \
+ modules.generic_string modules.ieee1394map \
+ modules.ieee1394map modules.pnpbiosmap \
+ modules.alias modules.ccwmap modules.inputmap \
+ modules.symbols modules.ofmap \
+ modules.seriomap modules.\*.bin \
+ modules.softdep modules.devname; do
+ eval rm -f /lib/modules/$version/$extra_file
+ done
+ rmdir /lib/modules/$version || true
+fi
+
+exit 0
diff --git a/meta/recipes-kernel/linux/files/debian/linux-image.preinst.tmpl b/meta/recipes-kernel/linux/files/debian/linux-image.preinst.tmpl
new file mode 100644
index 00000000..69821ae5
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/linux-image.preinst.tmpl
@@ -0,0 +1,26 @@
+#!/bin/sh -e
+# based on https://salsa.debian.org/kernel-team/linux/blob/479cb120ecb2b3f2c4d929a7b57860248d6f79bd/debian/templates/image.preinst.in
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Tell initramfs builder whether it's wanted
+export INITRD=Yes
+
+version=@KR@
+image_path=/boot/${KERNEL_FILE}-${version}
+
+if [ "$1" = abort-upgrade ]; then
+ exit 0
+fi
+
+if [ "$1" = install ]; then
+ # Create a flag file for postinst
+ mkdir -p /lib/modules/$version
+ touch /lib/modules/$version/.fresh-install
+fi
+
+if [ -d /etc/kernel/preinst.d ]; then
+ DEB_MAINT_PARAMS="$*" run-parts --report --exit-on-error --arg=$version \
+ --arg=$image_path /etc/kernel/preinst.d
+fi
+
+exit 0
diff --git a/meta/recipes-kernel/linux/files/debian/linux-image.prerm.tmpl b/meta/recipes-kernel/linux/files/debian/linux-image.prerm.tmpl
new file mode 100644
index 00000000..159ed671
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/linux-image.prerm.tmpl
@@ -0,0 +1,22 @@
+#!/bin/sh -e
+# based on https://salsa.debian.org/kernel-team/linux/blob/479cb120ecb2b3f2c4d929a7b57860248d6f79bd/debian/templates/image.prerm.in
+# SPDX-License-Identifier: GPL-2.0-only
+
+# Tell initramfs builder whether it's wanted
+export INITRD=Yes
+
+version=@KR@
+image_path=/boot/${KERNEL_FILE}-${version}
+
+if [ "$1" != remove ]; then
+ exit 0
+fi
+
+linux-check-removal $version
+
+if [ -d /etc/kernel/prerm.d ]; then
+ DEB_MAINT_PARAMS="$*" run-parts --report --exit-on-error --arg=$version \
+ --arg=$image_path /etc/kernel/prerm.d
+fi
+
+exit 0
diff --git a/meta/recipes-kernel/linux/files/debian/rules.tmpl b/meta/recipes-kernel/linux/files/debian/rules.tmpl
new file mode 100755
index 00000000..bea21f98
--- /dev/null
+++ b/meta/recipes-kernel/linux/files/debian/rules.tmpl
@@ -0,0 +1,39 @@
+#!/usr/bin/make -f
+
+CROSS_COMPILE:=$(DEB_HOST_GNU_TYPE)-
+
+O:=$(CURDIR)/${KERNEL_BUILD_DIR}
+S:=$(CURDIR)
+deb_top_dir:=$(S)/debian
+
+# Dynamic variables to be passed to Isar build scripts
+isar_env=$(strip \
+ export CROSS_COMPILE='$(CROSS_COMPILE)' && \
+ export DEB_BUILD_PROFILES='$(DEB_BUILD_PROFILES)' && \
+ export DEB_HOST_GNU_TYPE='$(DEB_HOST_GNU_TYPE)' && \
+ export MAKE='$(MAKE)' && \
+ export O='${O}' \
+ export S='${S}' \
+)
+
+%:
+ dh $(@)
+
+.PHONY: override_dh_auto_clean
+override_dh_auto_clean:
+ $(isar_env) && bash $(deb_top_dir)/isar/clean
+
+.PHONY: override_dh_auto_build
+override_dh_auto_build:
+ $(isar_env) && bash $(deb_top_dir)/isar/build
+
+override_dh_auto_install:
+ $(isar_env) && bash $(deb_top_dir)/isar/install
+
+.PHONY: override_dh_auto_test
+override_dh_auto_test:
+ true
+
+PHONY: override_dh_strip
+override_dh_strip:
+ unset DEB_HOST_GNU_TYPE && dh_strip -Xvmlinux --no-automatic-dbgsym
diff --git a/meta/recipes-kernel/linux/linux-custom.inc b/meta/recipes-kernel/linux/linux-custom.inc
index 712f52bd..d31da3bb 100644
--- a/meta/recipes-kernel/linux/linux-custom.inc
+++ b/meta/recipes-kernel/linux/linux-custom.inc
@@ -2,89 +2,181 @@
#
# This software is a part of ISAR.
# Copyright (c) Siemens AG, 2018
+# Copyright (c) Mentor Graphics, a Siemens business, 2019
#
# SPDX-License-Identifier: MIT
-FILESEXTRAPATHS_prepend := "${FILE_DIRNAME}/files:"
+# Settings that would typically be done from the custom kernel recipe
+# -------------------------------------------------------------------
+CHANGELOG_V = "${PV}+${PR}"
DESCRIPTION ?= "Custom kernel"
+MAINTAINER ?= "isar-users <isar-users@googlegroups.com>"
+
+KBUILD_DEPENDS ?= "build-essential:native, \
+ libelf-dev:native, \
+ libncurses-dev:native, \
+ libssl-dev:native, \
+ bc, \
+ bison, \
+ cpio, \
+ flex, \
+ git, \
+ kmod, \
+ libssl-dev,"
+
+KERNEL_DEBIAN_DEPENDS ?= "initramfs-tools | linux-initramfs-tool, \
+ kmod, \
+ linux-base (>= 4.3~),"
+
+KERNEL_HEADERS_DEBIAN_DEPENDS ?= "libc6, \
+ libssl1.1,"
+
+KERNEL_LIBC_DEV_DEPLOY ?= "0"
+
+# Settings that may be changed on a per distro, machine or layer basis
+# --------------------------------------------------------------------
+
+LINUX_VERSION_EXTENSION ?= ""
-KERNEL_NAME_PROVIDED ?= "${@ d.getVar('PN', True).partition('linux-')[2]}"
KERNEL_DEFCONFIG ?= ""
+# Add our template meta-data to the sources
+FILESEXTRAPATHS_prepend := "${FILE_DIRNAME}/files:"
+SRC_URI += "file://debian"
+
+# Variables and files that make our templates
+# -------------------------------------------
+
+TEMPLATE_FILES += " \
+ debian/control.tmpl \
+ debian/isar/build.tmpl \
+ debian/isar/clean.tmpl \
+ debian/isar/common.tmpl \
+ debian/isar/install.tmpl \
+ debian/isar/version.cfg.tmpl \
+ debian/linux-image.postinst.tmpl \
+ debian/linux-image.postrm.tmpl \
+ debian/linux-image.preinst.tmpl \
+ debian/linux-image.prerm.tmpl \
+ debian/rules.tmpl \
+"
+
+TEMPLATE_VARS += " \
+ HOST_ARCH \
+ KBUILD_DEPENDS \
+ KERNEL_ARCH \
+ KERNEL_DEBIAN_DEPENDS \
+ KERNEL_BUILD_DIR \
+ KERNEL_FILE \
+ KERNEL_HEADERS_DEBIAN_DEPENDS \
+ LINUX_VERSION_EXTENSION \
+ KERNEL_NAME_PROVIDED \
+"
+
+inherit dpkg
+inherit template
+
+# Derive name of the kernel packages from the name of this recipe
+KERNEL_NAME_PROVIDED ?= "${@ d.getVar('PN', True).partition('linux-')[2]}"
+
+# Make bitbake know we will be producing linux-image and linux-headers packages
python() {
kernel_name = d.getVar("KERNEL_NAME_PROVIDED", True)
d.setVar('PROVIDES', 'linux-image-' + kernel_name + ' ' + \
'linux-headers-' + kernel_name)
}
-inherit dpkg-base
-
-SRC_URI += "file://build-kernel.sh"
-
-KBUILD_DEPENDS ?= " \
- build-essential:native \
- libssl-dev \
- libelf-dev \
- bc \
- git \
- kmod \
- bison \
- flex \
- cpio \
- libncurses-dev"
-KERNEL_DEBIAN_DEPENDS ?= "initramfs-tools | linux-initramfs-tool, kmod, linux-base (>= 4.3~)"
-KERNEL_HEADERS_DEBIAN_DEPENDS ?= "libc6, libssl1.1"
-
-KERNEL_LIBC_DEV_DEPLOY ?= "0"
-
-do_install_builddeps() {
- dpkg_do_mounts
- E="${@ isar_export_proxies(d)}"
- sudo -E chroot ${BUILDCHROOT_DIR} \
- apt-get update \
- -o Dir::Etc::SourceList="sources.list.d/isar-apt.list" \
- -o Dir::Etc::SourceParts="-" \
- -o APT::Get::List-Cleanup="0"
- sudo -E chroot ${BUILDCHROOT_DIR} \
- apt-get install \
- -y -o Debug::pkgProblemResolver=yes \
- --no-install-recommends ${KBUILD_DEPENDS}
- dpkg_undo_mounts
+def get_kernel_arch(d):
+ distro_arch = d.getVar("DISTRO_ARCH")
+ if distro_arch == "amd64":
+ kernel_arch = "x86"
+ elif distro_arch == "arm64":
+ kernel_arch = "arm64"
+ elif distro_arch == "armhf":
+ kernel_arch = "arm"
+ elif distro_arch == "mipsel":
+ kernel_arch = "mips"
+ else:
+ kernel_arch = ""
+ return kernel_arch
+
+KERNEL_ARCH ??= "${@get_kernel_arch(d)}"
+
+def config_fragments(d):
+ fragments = []
+ sources = d.getVar("SRC_URI").split()
+ for s in sources:
+ _, _, local, _, _, parm = bb.fetch.decodeurl(s)
+ apply = parm.get("apply")
+ if apply == "no":
+ continue
+ base, ext = os.path.splitext(os.path.basename(local))
+ if ext and ext in (".cfg"):
+ fragments.append(local)
+ return fragments
+
+do_prepare_build_prepend() {
+ # copy meta-data over to source tree
+ rm -rf ${S}/debian
+ cp -r ${WORKDIR}/debian ${S}/
+
+ # remove templates from the source tree
+ find ${S}/debian -name *.tmpl | xargs rm -f
+
+ # rename install/remove hooks to match user-specified name for our linux-image package
+ mv ${S}/debian/linux-image.postinst ${S}/debian/linux-image-${KERNEL_NAME_PROVIDED}.postinst
+ mv ${S}/debian/linux-image.postrm ${S}/debian/linux-image-${KERNEL_NAME_PROVIDED}.postrm
+ mv ${S}/debian/linux-image.preinst ${S}/debian/linux-image-${KERNEL_NAME_PROVIDED}.preinst
+ mv ${S}/debian/linux-image.prerm ${S}/debian/linux-image-${KERNEL_NAME_PROVIDED}.prerm
+
+ # produce a changelog for our kernel build
+ deb_add_changelog
}
-addtask install_builddeps after do_prepare_build before do_dpkg_build
-# apt and reprepro may not run in parallel, acquire the Isar lock
-do_install_builddeps[lockfiles] += "${REPO_ISAR_DIR}/isar.lock"
-
-addtask devshell after do_install_builddeps
+# build directory for our "full" kernel build
+KERNEL_BUILD_DIR = "build-full"
-dpkg_runbuild() {
- chmod +x ${WORKDIR}/build-kernel.sh
- KERNEL_CONFIG_TARGET="${KERNEL_DEFCONFIG}"
+dpkg_configure_kernel() {
+ config_target="${KERNEL_DEFCONFIG}"
+ rm -rf ${S}/${KERNEL_BUILD_DIR} && mkdir -p ${S}/${KERNEL_BUILD_DIR}
if [ -n "${KERNEL_DEFCONFIG}" ]; then
if [ -e "${WORKDIR}/${KERNEL_DEFCONFIG}" ]; then
- cp ${WORKDIR}/${KERNEL_DEFCONFIG} ${S}/.config
- KERNEL_CONFIG_TARGET="olddefconfig"
+ cp ${WORKDIR}/${KERNEL_DEFCONFIG} ${S}/${KERNEL_BUILD_DIR}/.config
+ config_target="olddefconfig"
fi
else
- KERNEL_CONFIG_TARGET="defconfig"
+ config_target="defconfig"
fi
- E="${@ isar_export_proxies(d)}"
-
- export PV=${PV}
- export KERNEL_NAME=${KERNEL_NAME_PROVIDED}
-
- export KBUILD_DEPENDS="${KBUILD_DEPENDS}"
- export KERNEL_CONFIG_TARGET
- export KERNEL_DEBIAN_DEPENDS="${KERNEL_DEBIAN_DEPENDS}"
- export KERNEL_FILE="${KERNEL_FILE}"
- export KERNEL_HEADERS_DEBIAN_DEPENDS="${KERNEL_HEADERS_DEBIAN_DEPENDS}"
+ # copy config fragments over to the kernel tree
+ src_frags="${@ " ".join(config_fragments(d)) }"
+ out_frags="${@ " ".join(map(lambda frag: 'debian/fragments/' + frag, config_fragments(d))) }"
+ if [ -n "${LINUX_VERSION_EXTENSION}" ]; then
+ out_frags="${out_frags} debian/isar/version.cfg"
+ fi
+ rm -rf ${S}/debian/fragments
+ if [ -n "${src_frags}" ]; then
+ mkdir -p ${S}/debian/fragments
+ (cd ${WORKDIR} && cp ${src_frags} ${S}/debian/fragments/)
+ fi
- sudo -E chroot --userspec=$( id -u ):$( id -g ) ${BUILDCHROOT_DIR} ${PP}/build-kernel.sh ${PP}/${PPS} ${DISTRO_ARCH}
+ sudo -E chroot --userspec=$(id -u):$(id -g) ${BUILDCHROOT_DIR} sh -c " \
+ export ARCH=${KERNEL_ARCH} && \
+ cd ${PP}/${PPS} && \
+ make O=${KERNEL_BUILD_DIR} ${config_target} && \
+ ./scripts/kconfig/merge_config.sh \
+ -O ${KERNEL_BUILD_DIR}/ \
+ ${KERNEL_BUILD_DIR}/.config \
+ ${out_frags} \
+ "
+}
+dpkg_runbuild_prepend() {
+ profiles="${BASE_DISTRO}"
if [ "${KERNEL_LIBC_DEV_DEPLOY}" != "1" ]; then
- rm -f ${WORKDIR}/linux-libc-dev_${PV}*.deb
+ profiles="${profiles} nolibcdev"
fi
+ export DEB_BUILD_PROFILES="${profiles}"
+ dpkg_configure_kernel
}
--
2.16.4
^ permalink raw reply [flat|nested] 9+ messages in thread